<template>
  <div
    class="flex justify-center"
    @keydown.esc="fullImageSrc = undefined"
    tabindex="0"
  >
    <div
      class="m-5 shadow-2xl"
      v-if="fullImageSrc"
      @click="fullImageSrc = undefined"
      style="position: fixed;"
    >
      <button
        class="absolute text-3xl top-0 right-0 mr-3"
        title="Close the image"
      >×</button>
      <img
        class="rounded-md"
        :src="fullImageSrc"
      />
    </div>
    <div class="m-10  max-w-6xl">
      <div class="rounded max-w-xl mt-20 mb-40">
        <div class="title">
          Create an image recognition project
        </div>
        <p class="desc">
          Here you will find the few steps to train a Teachable Machine
          image model and use it in your adacraft project.
        </p>
        <p class="desc">
          In the
          <a
            href="https://teachablemachine.withgoogle.com"
            target="_blank"
            rel="noopener noreferrer"
            class="ada-link"
          >Teachable Machine home page</a>
          you will find more information about training as well as some project
          ideas.
        </p>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <img
          @click="showImage"
          src="../assets/how-to/vision/teachablemachine_step_1.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
        <div class="info-zone">
          <div class="header">
            Train a Teachable Machine model
          </div>
          <p class="desc">
            Go to the Teachable Machine 
            <a
              href="https://teachablemachine.withgoogle.com/train/image"
              target="_blank"
              rel="noopener noreferrer"
              class="ada-link"
            >image project page</a>
            and follow the instructions to create your image classes, add
            some images for each class (you can use the webcam) and train
            your model.
          </p>
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div class="info-zone">
          <div class="header">
            Export the model
          </div>
          <p class="desc">
            When your model is ready, you need to export it from Teachable
            Machine. Click on the "Export Model" button.
          </p>
        </div>
        <img
          @click="showImage"
          src="../assets/how-to/vision/teachablemachine_export_button.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <img
          @click="showImage"
          src="../assets/how-to/vision/teachablemachine_step_2.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
        <div class="info-zone">
          <div class="header">
            Upload your model
          </div>
          <p class="desc">
            In the next panel you will be able to upload the resulting model in
            a predefined Google drive location so you can use it from your
            adacraft project.
          </p>
          <p class="desc">
            To do so, click on the button "Upload my model".
          </p>
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div class="info-zone">
          <div class="header">
            Get the key for your model
          </div>
          <p class="desc">
            Now that your model is available online, to use it you need to
            get its key (which is "yHNp_zRXX" in this example).
          </p>
        </div>
        <img
          @click="showImage"
          src="../assets/how-to/vision/teachablemachine_step_3.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <img
          @click="showImage"
          src="../assets/how-to/vision/blocks.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
        <div class="info-zone">
          <div class="header">
            Use the model in your adacraft project
          </div>
          <p class="desc">
            You can now use the model from any adacraft project by setting the
            model key and using the other "Ada Vision" blocks.
          </p>
          <p class="desc">
            The example on the left is taken from this
            <a
              href="https://adacraft.org/project/273450370439578118"
              target="_blank"
              rel="noopener noreferrer"
              class="ada-link"
            >very simple project</a>.
          </p>
        </div>
      </div>

      <div class="rounded w-full flex flex-col md:flex-row my-20">
        <div class="info-zone">
          <div class="header">
            Bonus: continuous detection
          </div>
          <p class="desc">
            By default, the detection block takes only one shot and launches the
            prediction on it.
          </p>
          <p class="desc">
            If you want to continuously apply the detection on the
            camera be sure to add a forever loop.
          </p>
        </div>
        <img
          @click="showImage"
          src="../assets/how-to/vision/teachablemachine_step_4.png"
          class="block lg:block rounded-md m-4 max-w-xl"
        />
      </div>

      <div class="faq-line">
        <div class="header-faq">
          Frequently Asked Questions (FAQ)
        </div>
        <div class="info-zone-faq">
          <div class="sub-title-faq">
            How many classes do I need to define for my Teachable Machine model?
          </div>
          <p class="desc">
            You choose, that really depends on your idea, there is no real upper
            limit (beside the time you will need to gather the images!).
          </p>
          <p class="desc">
            But the model will select between several things, so be sure you
            have at least 2 classes.
          </p>
          <p class="desc">
            For example if you want a model that recognizes your face, create
            two classes, one with images of you in front of the camera and
            another with images from the camera with similar backgrounds but
            without you. The two classes can be named "me" and "not me" for
            example.
          </p>
        </div>
      </div>

    </div>
  </div>
</template>

<script>

export default {
  name: 'ThePageHowtoVision',
  data () {
    return {
      fullImageSrc: undefined
    }
  },
  methods: {
    showImage (event) {
      if (event.target && event.target.src) {
        this.fullImageSrc = event.target.src
      }
    }
  }
}
</script>

<style lang="postcss" scoped>
.title {
  @apply md:mt-0 mb-20;
  @apply font-semibold;
  @apply text-6xl text-gray-800;
  @apply dark:text-gray-300;
}

.desc {
  @apply block;
  @apply p-2 pl-0 pt-1;
  @apply text-xl text-gray-600;
  @apply dark:text-gray-400;
}

.info-zone {
  @apply px-4 max-w-xs;
  @apply bg-white;
  @apply dark:bg-gray-800;
}

.info-zone-faq {
  @apply px-4;
  @apply bg-white;
  @apply dark:bg-gray-800;
}

.header {
  @apply md:mt-0 mb-2;
  @apply font-semibold;
  @apply text-2xl text-gray-800;
  @apply dark:text-gray-300;
}

.header-faq {
  @apply md:mt-0 mb-10;
  @apply font-semibold;
  @apply text-4xl text-gray-800;
  @apply dark:text-gray-300;
}

.faq-line {
  @apply max-w-4xl my-40 pt-40;
  @apply border-t;
  @apply dark:border-purple-900;
}

.sub-title-faq {
  @apply md:mt-0 mb-2;
  @apply text-2xl text-gray-800;
  @apply dark:text-gray-300;
  @apply font-semibold;
}
</style>